%global momorel 2
%global src_year 2005
%global src_month 02
%global src_day 08
%global src_date %{src_year}-%{src_month}-%{src_day}
%global rel 0.%{src_year}%{src_month}%{src_day}.%{momorel}

Summary: FFmpeg Streaming Multimedia System
Name: ffmpeg
Version: 0.4.9
%global src_name %{name}-%{version}
%global src_extract_name %{name}-cvs-%{src_date} 

#Release: %{momorel}m
Release: %{rel}m
License: GPL
Group: Development/Libraries
Source0: http://ffmpeg.sourceforge.net/cvs/ffmpeg-cvs-%{src_date}.tar.gz
# Source0: http://telia.dl.sourceforge.net/sourceforge/ffmpeg/%{src_name}.tar.gz
NoSource: 0

Patch0: ffmpeg-0.4.8-kernel2681.patch
#Patch1: ffmpeg-0.4.8-lib64.patch

#Patch10: ffmpeg-0.4.9-pre1-sharedppfix.patch
#Patch12: ffmpeg-0.4.9-pre1-pic.patch
Patch13: ffmpeg-cvs-ldlibs.patch

URL: http://ffmpeg.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-root/
BuildPreReq: libvorbis-devel, a52dec-devel, faad2-devel, lame-devel
BuildPreReq: zlib-devel >= 1.1.4-5m
Requires: SDL >= 1.2.7-9m
%if %{_lib} == "lib64"
Provides: libavcodec.so()(64bit)
Provides: libavformat.so()(64bit)
%else
Provides: libavcodec.so
Provides: libavformat.so
%endif

### include local configuration
%{?include_specopt}
# just a sample
# %%define extraconfopt --enable-mp3lame
# --enable-facc -enable-xvid
# --enable-pp --enable-shared-pp --enable-shared --enable-gpl --disable-strip

%description
ffmpeg is a hyper fast realtime audio/video encoder, a streaming
server and a generic audio and video file converter.

It can grab from a standard Video4Linux video source and convert it
into several file formats based on DCT/motion compensation
encoding. Sound is compressed in MPEG audio layer 2 or using an AC3
compatible stream.

%package devel
Summary: Header files and static library for the ffmpeg codec library
Group: Development/Libraries
Requires: %{name} = %{version}
Requires: imlib2-devel, SDL-devel, freetype2-devel, zlib-devel

%description devel
FFmpeg is a very fast video and audio converter. It can also grab from a
live audio/video source.
The command line interface is designed to be intuitive, in the sense that
ffmpeg tries to figure out all the parameters, when possible. You have
usually to give only the target bitrate you want. FFmpeg can also convert
from any sample rate to any other, and resize video on the fly with a high
quality polyphase filter.

Install this package if you want to compile apps with ffmpeg support.

%package -n libpostproc
Summary: Video postprocessing library from ffmpeg
Group: System Environment/Libraries
# We need to override version here... when libpostproc was built from
# MPlayer, it got up to 1.0-0.11.x) - mach barfs! :-(
#Version: 1.0.1
Provides: libpostproc-devel = %{version}-%{release}

%description -n libpostproc
FFmpeg is a very fast video and audio converter. It can also grab from a
live audio/video source.

This package contains only ffmpeg's libpostproc post-processing library which
other projects such as transcode may use. Install this package if you intend
to use MPlayer, transcode or other similar programs.


%prep
#%%setup -q
%setup -q -n %{src_extract_name} 
%patch0 -p1
#%%if %{_lib} == "lib64"
#%%patch1 -p1 -b .lib64~
#%%endif

#patch10 -p1 -b .sharedpp
#patch12 -p1 -b .pic
%patch13

### FIXME: Make Makefile use autotool directory standard. (Please fix upstream)
%{__perl} -pi -e 's|\$\(prefix\)/lib|\$(libdir)|g;
                  s|\$\(prefix\)/include|\$(includedir)|g' \
                  Makefile */Makefile */*/Makefile

%build
find . -name "CVS" | xargs rm -rf
CFLAGS="%optflags -fno-unit-at-a-time" \
  %configure --enable-vorbis \
  --enable-mp3lame --enable-faad --enable-a52 --enable-gpl \
  --enable-shared --enable-pp --enable-shared-pp --enable-gpl \
  %{?extraconfopt}
make clean
%{__make} %{?_smp_mflags} -C libavcodec/libpostproc
%{__make} %{?_smp_mflags}
# make -C doc
%{__make} documentation
# Leftover, for reference :
# OPTFLAGS="-fPIC -fomit-frame-pointer %{optflags} -UUSE_FASTMEMCPY"

%install
rm -rf %{buildroot}
%makeinstall -C libavcodec/libpostproc
%makeinstall

### Make installlib is broken in 0.4.6-8, so we do it by hand
%{__install} -D -m0644 libavcodec/libavcodec.a \
    %{buildroot}%{_libdir}/libavcodec.a
%{__install} -D -m0644 libavformat/libavformat.a \
    %{buildroot}%{_libdir}/libavformat.a

# Remove from the included docs
%{__rm} -rf doc/{CVS,Makefile}

%clean
%{__rm} -rf %{buildroot}

%post
/sbin/ldconfig

%postun
if [ "$1" = 0 ]; then
    /sbin/ldconfig
fi

%post -n libpostproc
/sbin/ldconfig

%postun -n libpostproc
/sbin/ldconfig

%files
%defattr(-, root, root, 0755)
%doc Changelog COPYING CREDITS README
%{_bindir}/*
%{_libdir}/*.so
%exclude %{_libdir}/libpostproc.so*
%{_libdir}/vhook/
%{_mandir}/man1/*

%files devel
%defattr(-, root, root, 0755)
%doc doc/*
%{_includedir}/ffmpeg/
%{_libdir}/*.a

%files -n libpostproc
%defattr(-, root, root, 0755)
%{_includedir}/postproc/
%{_libdir}/libpostproc.so*

%changelog
* Sat May 07 2005 Toru Hoshina <t@momonga-linux.org>
- (0.4.9-0.20050208.2m)
- enable x86_64. no more lib64 patch.

* Sat May 07 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.9-0.20050208.1m)
- update to cvs version
- * Sat Jan 15 2005 Dag Wieers <dag@wieers.com> - 0.4.9-0.20041110.3
- - Exclude libpostproc.so* from ffmpeg package.

* Fri Feb 18 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.8-7m)
- add lib64 patch.

* Tue Feb 16 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.4.8-6m)
- roll buck to 0.4.8

* Sat Feb 12 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (0.4.9-0.0.1.4m)
- rebuild against SDL-1.2.7-9m

* Fri Feb 11 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.9-0.0.1.3m)
- renew lib64 patch

* Wed Feb  9 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.9-0.0.1.2m)
- enable lame, faad, and a52 support

* Mon Feb  7 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.9-0.0.1.1m)
- update 0.4.9 pre1

* Mon Feb  7 2005 Dai OKUYAMA <dai@ouchi.nahi.to>
- (0.4.8-5m)
- enable x86_64.

* Mon Oct 25 2004 Shigeyuki Yamashita <shige@momonga-linux.org>
- (0.4.8-4m)
- append CFLAGS fno-unit-at-a-time for compilation problems.

* Sat Aug 28 2004 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.4.8-3m)
- add Patch0: ffmpeg-0.4.8-kernel2681.patch

* Sat Apr 24 2004 Toru Hoshina <t@momomnga-linux.org>
- (0.1-7m)
- explicitly provides libavcodec.so and libavformat.so for anaconda.

* Thu Mar 18 2004 Toru Hoshina <t@momonga-linux.org>
- (0.4.8-2m)
- revised spec for enabling rpm 4.2.

* Wed Nov  5 2003 Masayuki SANO <sano@acs.i.kyoto-u.ac.jp>
- (0.4.8-1m)
- update to 0.4.8

* Tue Aug 26 2003 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.7-1m)

* Tue Apr 08 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.4.6-0.20021210.2m)
- rebuild against zlib 1.1.4-5m

* Wed Dec 11 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20021210.1m)

* Sun Nov 10 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20021110.1m)

* Sat Sep  7 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.4.6-0.20020907.1m)
- initial import to Momonga
